

`timescale 1ns / 100ps


module top (
    input i_clk, //50M
	
	


    output  o_led1,
    output  o_led2,
    output  o_led3,
    output  o_led4,

    input i_key1,
    input i_key2,
    input i_key3,
    input i_key4,

    input i_sw1,
    input i_sw2,
    input i_sw3,
    input i_sw4,

	output wire   TX_CLK_P,
	output wire   TX_CLK_N,
	output wire   TX_DATA_P,
	output wire   TX_DATA_N,
	input  wire   RX_CLK_P,
	input  wire   RX_CLK_N,
	input  wire   RX_DATA_P,
	input  wire   RX_DATA_N,	
	
	
    output     o_tx,
    input      i_rx,  

    output     o_ltpiuart,
    input      i_ltpiuart,


    inout      smb_scl_io,
    inout      smb_sda_io


);


wire syspll_locked;
wire w_clk60m;
wire w_clk25m;
wire w_clk60m_rst_n;
wire w_clk25m_rst_n;

reg [5:0]r_clk60_cnt = 0;
reg [5:0]r_clk25_cnt = 0;

syspll_rPLL u0_syspll_rPLL(
    .clkout(w_clk60m), //output clkout
    .lock(syspll_locked), //output lock
    .clkin(i_clk) //input clkin
);

CLKDIV u1_CLKDIV (
    .HCLKIN(i_clk),
    .RESETN(syspll_locked),
    .CALIB(1'b0),
    .CLKOUT(w_clk25m)
);

defparam u1_CLKDIV.DIV_MODE="2";
defparam u1_CLKDIV.GSREN="false";


always @(posedge w_clk60m or negedge syspll_locked)
begin
    if(syspll_locked == 0)
        r_clk60_cnt <= 0;
    else 
        r_clk60_cnt <= &r_clk60_cnt ? r_clk60_cnt : r_clk60_cnt + 1;
end
assign w_clk60m_rst_n = r_clk60_cnt[5];

always @(posedge w_clk25m or negedge syspll_locked)
begin
    if(syspll_locked == 0)
        r_clk25_cnt <= 0;
    else 
        r_clk25_cnt <= &r_clk25_cnt ? r_clk25_cnt : r_clk25_cnt + 1;
end
assign w_clk25m_rst_n = r_clk25_cnt[5];






wire [31:0] reg0x0000;wire [31:0] reg0x0010;wire [31:0] mon0x0080;wire [31:0] mon0x0090;
wire [31:0] reg0x0001;wire [31:0] reg0x0011;wire [31:0] mon0x0081;wire [31:0] mon0x0091;
wire [31:0] reg0x0002;wire [31:0] reg0x0012;wire [31:0] mon0x0082;wire [31:0] mon0x0092;
wire [31:0] reg0x0003;wire [31:0] reg0x0013;wire [31:0] mon0x0083;wire [31:0] mon0x0093;
wire [31:0] reg0x0004;wire [31:0] reg0x0014;wire [31:0] mon0x0084;wire [31:0] mon0x0094;
wire [31:0] reg0x0005;wire [31:0] reg0x0015;wire [31:0] mon0x0085;wire [31:0] mon0x0095;
wire [31:0] reg0x0006;wire [31:0] reg0x0016;wire [31:0] mon0x0086;wire [31:0] mon0x0096;
wire [31:0] reg0x0007;wire [31:0] reg0x0017;wire [31:0] mon0x0087;wire [31:0] mon0x0097;
wire [31:0] reg0x0008;wire [31:0] reg0x0018;wire [31:0] mon0x0088;wire [31:0] mon0x0098;
wire [31:0] reg0x0009;wire [31:0] reg0x0019;wire [31:0] mon0x0089;wire [31:0] mon0x0099;
wire [31:0] reg0x000A;wire [31:0] reg0x001A;wire [31:0] mon0x008A;wire [31:0] mon0x009A;
wire [31:0] reg0x000B;wire [31:0] reg0x001B;wire [31:0] mon0x008B;wire [31:0] mon0x009B;
wire [31:0] reg0x000C;wire [31:0] reg0x001C;wire [31:0] mon0x008C;wire [31:0] mon0x009C;
wire [31:0] reg0x000D;wire [31:0] reg0x001D;wire [31:0] mon0x008D;wire [31:0] mon0x009D;
wire [31:0] reg0x000E;wire [31:0] reg0x001E;wire [31:0] mon0x008E;wire [31:0] mon0x009E;
wire [31:0] reg0x000F;wire [31:0] reg0x001F;wire [31:0] mon0x008F;wire [31:0] mon0x009F;



wire               w_apb0_clk/* synthesis syn_preserve = 1 */;
wire               w_apb0_rstn/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb0_addr/* synthesis syn_preserve = 1 */;
wire               w_apb0_sel /* synthesis syn_preserve = 1 */;
wire               w_apb0_ena /* synthesis syn_preserve = 1 */;
wire               w_apb0_wr  /* synthesis syn_preserve = 1 */;
wire[31:0]         w_apb0_rdata/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb0_wdata/* synthesis syn_preserve = 1 */;
wire               w_apb0_rdy/* synthesis syn_preserve = 1 */;
wire  [3:0]        w_apb0_strb/* synthesis syn_preserve = 1 */;


wire               w_apb1_clk  /* synthesis syn_preserve = 1 */;
wire               w_apb1_rstn /* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb1_addr /* synthesis syn_preserve = 1 */;
wire               w_apb1_sel  /* synthesis syn_preserve = 1 */;
wire               w_apb1_ena  /* synthesis syn_preserve = 1 */;
wire               w_apb1_wr   /* synthesis syn_preserve = 1 */;
wire[31:0]         w_apb1_rdata/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb1_wdata/* synthesis syn_preserve = 1 */;
wire               w_apb1_rdy  /* synthesis syn_preserve = 1 */;
wire  [3:0]        w_apb1_strb /* synthesis syn_preserve = 1 */;

wire               w_apb2_clk  /* synthesis syn_preserve = 1 */;
wire               w_apb2_rstn /* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb2_addr /* synthesis syn_preserve = 1 */;
wire               w_apb2_sel  /* synthesis syn_preserve = 1 */;
wire               w_apb2_ena  /* synthesis syn_preserve = 1 */;
wire               w_apb2_wr   /* synthesis syn_preserve = 1 */;
wire[31:0]         w_apb2_rdata/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb2_wdata/* synthesis syn_preserve = 1 */;
wire               w_apb2_rdy  /* synthesis syn_preserve = 1 */;
wire  [3:0]        w_apb2_strb /* synthesis syn_preserve = 1 */;





wire                        uart_rx_led/* synthesis syn_preserve = 1 */;
wire                        uart_tx_led/* synthesis syn_preserve = 1 */;
wire                        uart_rx_err/* synthesis syn_preserve = 1 */;
                                                              

Uart_to_Bus_Top u_Uart_to_Bus_Top(
	.rst_n_i                  (w_clk25m_rst_n ),                        
	.clk_i                    (w_clk25m       ),                
	.uart_rx_led_o            (uart_rx_led    ),
	.uart_tx_led_o            (uart_tx_led    ),
	.uart_rx_i                (i_rx           ),
	.uart_tx_o                (o_tx           ),
    .apb0_addr_o              (w_apb0_addr    ),
    .apb0_sel_o               (w_apb0_sel     ),
    .apb0_ena_o               (w_apb0_ena     ),
    .apb0_wr_o                (w_apb0_wr      ),
    .apb0_rdata_i             (w_apb0_rdata   ),
    .apb0_wdata_o             (w_apb0_wdata   ),
    .apb0_rdy_i               (w_apb0_rdy     ),
    .apb0_strb_o              (w_apb0_strb    ),   

    .apb1_addr_o              (w_apb1_addr    ),
    .apb1_sel_o               (w_apb1_sel     ),
    .apb1_ena_o               (w_apb1_ena     ),
    .apb1_wr_o                (w_apb1_wr      ),
    .apb1_rdata_i             (w_apb1_rdata   ),
    .apb1_wdata_o             (w_apb1_wdata   ),
    .apb1_rdy_i               (w_apb1_rdy     ),
    .apb1_strb_o              (w_apb1_strb    ),

    .apb2_addr_o              (w_apb2_addr    ),
    .apb2_sel_o               (w_apb2_sel     ),
    .apb2_ena_o               (w_apb2_ena     ),
    .apb2_wr_o                (w_apb2_wr      ),
    .apb2_rdata_i             (w_apb2_rdata   ),
    .apb2_wdata_o             (w_apb2_wdata   ),
    .apb2_rdy_i               (w_apb2_rdy     ),
    .apb2_strb_o              (w_apb2_strb    )


);


wire           local_wren_w/* synthesis syn_preserve = 1 */;
wire [29:0]    local_addr_w/* synthesis syn_preserve = 1 */;
wire           local_rden_w/* synthesis syn_preserve = 1 */;
wire [31:0]    local_wdat_w/* synthesis syn_preserve = 1 */;
wire [31:0]    local_rdat_w/* synthesis syn_preserve = 1 */;
wire [3 :0]    local_strb_w/* synthesis syn_preserve = 1 */;
wire           local_rdat_vld_w/* synthesis syn_preserve = 1 */;
wire           local_wdat_rdy_w/* synthesis syn_preserve = 1 */;


assign w_apb0_clk = w_clk25m;
assign w_apb1_clk = w_clk25m;


assign w_apb0_rstn = w_clk25m_rst_n;
assign w_apb1_rstn = w_clk25m_rst_n;
	


apb2local u_apb2local
(

	.cfg_clk_i  (w_apb0_clk     ),
	.cfg_rstn_i (w_apb0_rstn    ),
	.cfg_addr_i (w_apb0_addr    ),
	.cfg_sel_i  (w_apb0_sel     ),
	.cfg_ena_i  (w_apb0_ena     ),
	.cfg_wr_i   (w_apb0_wr      ),
	.cfg_rdata_o(w_apb0_rdata   ),
	.cfg_wdata_i(w_apb0_wdata   ),
	.cfg_rdy_o  (w_apb0_rdy     ),
	.cfg_strb_i (w_apb0_strb    ),
	
	.local_wren_o(local_wren_w),
	.local_addr_o(local_addr_w),
	.local_strb_o(local_strb_w),
	.local_rden_o(local_rden_w),
	.local_wdat_o(local_wdat_w),
	.local_rdat_i(local_rdat_w),
	.local_rdat_vld_i(local_rdat_vld_w),
	.local_wdat_rdy_i(local_wdat_rdy_w)


);



local2reg u_local2reg
(

	.cfg_clk_i(w_apb0_clk),
	.cfg_rstn_i(w_apb0_rstn),
	.local_wren_i(local_wren_w),
	.local_addr_i(local_addr_w),
	.local_strb_i(4'hf),	
	.local_rden_i(local_rden_w),
	.local_wdat_i(local_wdat_w),
	.local_rdat_o(local_rdat_w),
	.local_rdat_vld_o(local_rdat_vld_w),
	.local_wdat_rdy_o(local_wdat_rdy_w),	
	
	
	.reg0x0000(reg0x0000),.reg0x0010(reg0x0010),.mon0x0080(mon0x0080),.mon0x0090(mon0x0090),
	.reg0x0001(reg0x0001),.reg0x0011(reg0x0011),.mon0x0081(mon0x0081),.mon0x0091(mon0x0091),
	.reg0x0002(reg0x0002),.reg0x0012(reg0x0012),.mon0x0082(mon0x0082),.mon0x0092(mon0x0092),
    .reg0x0003(reg0x0003),.reg0x0013(reg0x0013),.mon0x0083(mon0x0083),.mon0x0093(mon0x0093),
    .reg0x0004(reg0x0004),.reg0x0014(reg0x0014),.mon0x0084(mon0x0084),.mon0x0094(mon0x0094),
    .reg0x0005(reg0x0005),.reg0x0015(reg0x0015),.mon0x0085(mon0x0085),.mon0x0095(mon0x0095),
    .reg0x0006(reg0x0006),.reg0x0016(reg0x0016),.mon0x0086(mon0x0086),.mon0x0096(mon0x0096),
    .reg0x0007(reg0x0007),.reg0x0017(reg0x0017),.mon0x0087(mon0x0087),.mon0x0097(mon0x0097),
    .reg0x0008(reg0x0008),.reg0x0018(reg0x0018),.mon0x0088(mon0x0088),.mon0x0098(mon0x0098),
    .reg0x0009(reg0x0009),.reg0x0019(reg0x0019),.mon0x0089(mon0x0089),.mon0x0099(mon0x0099),
    .reg0x000A(reg0x000A),.reg0x001A(reg0x001A),.mon0x008A(mon0x008A),.mon0x009A(mon0x009A),
    .reg0x000B(reg0x000B),.reg0x001B(reg0x001B),.mon0x008B(mon0x008B),.mon0x009B(mon0x009B),
    .reg0x000C(reg0x000C),.reg0x001C(reg0x001C),.mon0x008C(mon0x008C),.mon0x009C(mon0x009C),
    .reg0x000D(reg0x000D),.reg0x001D(reg0x001D),.mon0x008D(mon0x008D),.mon0x009D(mon0x009D),
    .reg0x000E(reg0x000E),.reg0x001E(reg0x001E),.mon0x008E(mon0x008E),.mon0x009E(mon0x009E),
    .reg0x000F(reg0x000F),.reg0x001F(reg0x001F),.mon0x008F(mon0x008F),.mon0x009F(mon0x009F)   
	
	
	
);





wire  lvds_tx_data;
wire  lvds_tx_clk ;
wire  lvds_rx_data;
wire  lvds_rx_clk ;


wire  [31:0]oem_gpio_in;   
wire  [31:0]oem_gpio_out;  

wire  [15:0]ll_gpio_in;   //KEY
wire [15:0]ll_gpio_out;  //led
wire  [31:0]nl_gpio_in;   //SW
wire [31:0]nl_gpio_out;
wire [1:0]uart_rxd;
wire [1:0]uart_txd;
wire [5:0]debug;

DCSCM_LTPI_Top u_ltpi_scm
(
     .clk_i      (w_clk60m),           
     .ref_clk_i  (w_clk25m),        
     .rstn_i     (w_clk60m_rst_n),
     .start_i    (~reg0x0000[0]),

     //LVDS output pins
     .lvds_tx_data_o(lvds_tx_data),
     .lvds_tx_clk_o (lvds_tx_clk),

     //LVDS input pins
     .lvds_rx_data_i(lvds_rx_data),
     .lvds_rx_clk_i (lvds_rx_clk),
     .tx_pll_locked_o (mon0x0081),
     .aligned_o       (mon0x0082),           

     .ll_gpio_in_i (ll_gpio_in),
     .ll_gpio_out_o(ll_gpio_out),

     .nl_gpio_in_i (nl_gpio_in),        
     .nl_gpio_out_o(nl_gpio_out),

     .uart_rxd_i (uart_rxd),           
     //.uart_cts_i (1'b0),          
     .uart_txd_o (uart_txd),
     //.uart_rts_o (),           

    .iic_scl_io  (smb_scl_io),           
    .iic_sda_io  (smb_sda_io),

    .oem_gpio_in_i  (oem_gpio_in ),
    .oem_gpio_out_o (oem_gpio_out),


	.apb_addr_i  (w_apb2_addr    ),
	.apb_sel_i   (w_apb2_sel     ),
	.apb_ena_i   (w_apb2_ena     ),
	.apb_wr_i    (w_apb2_wr      ),
	.apb_rdata_o (w_apb2_rdata   ),
	.apb_wdata_i (w_apb2_wdata   ),
	.apb_rdy_o   (w_apb2_rdy     ),
    .apb_err_o   (               ),
	.apb_strb_i  (w_apb2_strb    ),



	.cfg_clk_i   (w_apb1_clk     ),
	.cfg_rstn_i  (w_apb1_rstn    ),
	.cfg_addr_i  (w_apb1_addr    ),
	.cfg_sel_i   (w_apb1_sel     ),
	.cfg_ena_i   (w_apb1_ena     ),
	.cfg_wr_i    (w_apb1_wr      ),
	.cfg_rdata_o (w_apb1_rdata   ),
	.cfg_wdata_i (w_apb1_wdata   ),
	.cfg_rdy_o   (w_apb1_rdy     ),
	.cfg_strb_i  (w_apb1_strb    ),
    .data_channel_tag_i(reg0x0001[7:0]),
    .data_channel_tag_o(mon0x0084[7:0]),
    .debug_o(debug)
		

   );

assign mon0x0083 = debug[5:2];


/*
reg [19:0]counter = 0;
always @(posedge w_clk60m)
begin
    counter <= counter + 1;
    ll_gpio_in <= (&counter) ?  ll_gpio_in + 1 : ll_gpio_in;

end
*/


assign  ll_gpio_in[15]    = 0;
assign  ll_gpio_in[0]     = i_key1;
assign  ll_gpio_in[14:1]  = 0;

assign  oem_gpio_in[31]    = 0;
assign  oem_gpio_in[0]     = i_key4;
assign  oem_gpio_in[30:1]  = 0;


assign nl_gpio_in[0] = i_key2;
assign nl_gpio_in[31] = i_key3;
assign nl_gpio_in[30:1] = 30'h0;

assign o_led1 = ll_gpio_out[0];
assign o_led2 = nl_gpio_out[0];
assign o_led3 = nl_gpio_out[31];
assign o_led4 = oem_gpio_out[0];

assign uart_rxd[0] = i_ltpiuart;
assign uart_rxd[1] = 1'b1;

assign o_ltpiuart = uart_txd[0];


//assign  ll_gpio_in = reg0x0001[15:0];   //{i_key4,i_key3,i_key2,i_key1};   //KEY
//assign  nl_gpio_in = reg0x0002[15:0];   //{i_key4,i_key3,i_key2,i_key1};   //SW
//assign {o_led4,o_led3,o_led2,o_led1} = ll_gpio_out;  //nl_gpio_out

//assign mon0x0081 = ll_gpio_out;
//assign mon0x0082 = nl_gpio_out;

TLVDS_OBUF lvds_tx_data_out(
  .O(TX_DATA_P),
  .OB(TX_DATA_N),
  .I(lvds_tx_data) //DATA
);


TLVDS_OBUF lvds_tx_clk_out(
  .O(TX_CLK_P),
  .OB(TX_CLK_N),
  .I(lvds_tx_clk) //CLK
); 
   

TLVDS_IBUF lvds_rx_clk_in(
  .O(lvds_rx_clk),
  .I(RX_CLK_P),
  .IB(RX_CLK_N)
);


TLVDS_IBUF lvds_rx_data_in(
  .O(lvds_rx_data),
  .I(RX_DATA_P),
  .IB(RX_DATA_N)
);

   


assign mon0x008A = 32'h20240116;
assign mon0x008B = 32'h00000001;




endmodule






