

`timescale 1ns / 100ps


module top (
    input i_clk, //50M
	
	
	
    output     o_tx,
    input      i_rx,  //调试串口


    inout     io_eeprom_scl,
    inout     io_eeprom_sda,

    output    scl_pullup,
    output    sda_pullup

);

assign scl_pullup = 1;
assign sda_pullup = 1;



wire syspll_locked;
wire w_clk100m;
wire w_clk100m_rst_n;


reg [5:0]r_clk100_cnt = 0;

syspll_rPLL u0_syspll_rPLL(
    .clkout(w_clk100m), //output clkout
    .lock(syspll_locked), //output lock
    .clkin(i_clk) //input clkin
);





always @(posedge w_clk100m or negedge syspll_locked)
begin
    if(syspll_locked == 0)
        r_clk100_cnt <= 0;
    else 
        r_clk100_cnt <= &r_clk100_cnt ? r_clk100_cnt : r_clk100_cnt + 1;
end
assign w_clk100m_rst_n = r_clk100_cnt[5];





wire [31:0] reg0x0000;wire [31:0] reg0x0010;wire [31:0] mon0x0080;wire [31:0] mon0x0090;
wire [31:0] reg0x0001;wire [31:0] reg0x0011;wire [31:0] mon0x0081;wire [31:0] mon0x0091;
wire [31:0] reg0x0002;wire [31:0] reg0x0012;wire [31:0] mon0x0082;wire [31:0] mon0x0092;
wire [31:0] reg0x0003;wire [31:0] reg0x0013;wire [31:0] mon0x0083;wire [31:0] mon0x0093;
wire [31:0] reg0x0004;wire [31:0] reg0x0014;wire [31:0] mon0x0084;wire [31:0] mon0x0094;
wire [31:0] reg0x0005;wire [31:0] reg0x0015;wire [31:0] mon0x0085;wire [31:0] mon0x0095;
wire [31:0] reg0x0006;wire [31:0] reg0x0016;wire [31:0] mon0x0086;wire [31:0] mon0x0096;
wire [31:0] reg0x0007;wire [31:0] reg0x0017;wire [31:0] mon0x0087;wire [31:0] mon0x0097;
wire [31:0] reg0x0008;wire [31:0] reg0x0018;wire [31:0] mon0x0088;wire [31:0] mon0x0098;
wire [31:0] reg0x0009;wire [31:0] reg0x0019;wire [31:0] mon0x0089;wire [31:0] mon0x0099;
wire [31:0] reg0x000A;wire [31:0] reg0x001A;wire [31:0] mon0x008A;wire [31:0] mon0x009A;
wire [31:0] reg0x000B;wire [31:0] reg0x001B;wire [31:0] mon0x008B;wire [31:0] mon0x009B;
wire [31:0] reg0x000C;wire [31:0] reg0x001C;wire [31:0] mon0x008C;wire [31:0] mon0x009C;
wire [31:0] reg0x000D;wire [31:0] reg0x001D;wire [31:0] mon0x008D;wire [31:0] mon0x009D;
wire [31:0] reg0x000E;wire [31:0] reg0x001E;wire [31:0] mon0x008E;wire [31:0] mon0x009E;
wire [31:0] reg0x000F;wire [31:0] reg0x001F;wire [31:0] mon0x008F;wire [31:0] mon0x009F;



wire               w_apb0_clk/* synthesis syn_preserve = 1 */;
wire               w_apb0_rstn/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb0_addr/* synthesis syn_preserve = 1 */;
wire               w_apb0_sel /* synthesis syn_preserve = 1 */;
wire               w_apb0_ena /* synthesis syn_preserve = 1 */;
wire               w_apb0_wr  /* synthesis syn_preserve = 1 */;
wire[31:0]         w_apb0_rdata/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb0_wdata/* synthesis syn_preserve = 1 */;
wire               w_apb0_rdy/* synthesis syn_preserve = 1 */;
wire  [3:0]        w_apb0_strb/* synthesis syn_preserve = 1 */;


wire               w_apb1_clk  /* synthesis syn_preserve = 1 */;
wire               w_apb1_rstn /* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb1_addr /* synthesis syn_preserve = 1 */;
wire               w_apb1_sel  /* synthesis syn_preserve = 1 */;
wire               w_apb1_ena  /* synthesis syn_preserve = 1 */;
wire               w_apb1_wr   /* synthesis syn_preserve = 1 */;
wire[31:0]         w_apb1_rdata/* synthesis syn_preserve = 1 */;
wire  [31:0]       w_apb1_wdata/* synthesis syn_preserve = 1 */;
wire               w_apb1_rdy  /* synthesis syn_preserve = 1 */;
wire  [3:0]        w_apb1_strb /* synthesis syn_preserve = 1 */;




wire                        uart_rx_led/* synthesis syn_preserve = 1 */;
wire                        uart_tx_led/* synthesis syn_preserve = 1 */;
wire                        uart_rx_err/* synthesis syn_preserve = 1 */;
                                                              

Uart_to_Bus_Top u_Uart_to_Bus_Top(
	.rst_n_i                  (w_clk100m_rst_n ),                        
	.clk_i                    (w_clk100m       ),                
	.uart_rx_led_o            (uart_rx_led    ),
	.uart_tx_led_o            (uart_tx_led    ),
	.uart_rx_i                (i_rx           ),
	.uart_tx_o                (o_tx           ),
    .apb0_addr_o              (w_apb0_addr    ),
    .apb0_sel_o               (w_apb0_sel     ),
    .apb0_ena_o               (w_apb0_ena     ),
    .apb0_wr_o                (w_apb0_wr      ),
    .apb0_rdata_i             (w_apb0_rdata   ),
    .apb0_wdata_o             (w_apb0_wdata   ),
    .apb0_rdy_i               (w_apb0_rdy     ),
    .apb0_strb_o              (w_apb0_strb    ),   

    .apb1_addr_o              (w_apb1_addr    ),
    .apb1_sel_o               (w_apb1_sel     ),
    .apb1_ena_o               (w_apb1_ena     ),
    .apb1_wr_o                (w_apb1_wr      ),
    .apb1_rdata_i             (w_apb1_rdata   ),
    .apb1_wdata_o             (w_apb1_wdata   ),
    .apb1_rdy_i               (w_apb1_rdy     ),
    .apb1_strb_o              (w_apb1_strb    )


);


wire           local_wren_w/* synthesis syn_preserve = 1 */;
wire [29:0]    local_addr_w/* synthesis syn_preserve = 1 */;
wire           local_rden_w/* synthesis syn_preserve = 1 */;
wire [31:0]    local_wdat_w/* synthesis syn_preserve = 1 */;
wire [31:0]    local_rdat_w/* synthesis syn_preserve = 1 */;
wire [3 :0]    local_strb_w/* synthesis syn_preserve = 1 */;
wire           local_rdat_vld_w/* synthesis syn_preserve = 1 */;
wire           local_wdat_rdy_w/* synthesis syn_preserve = 1 */;


assign w_apb0_clk = w_clk100m;
assign w_apb1_clk = w_clk100m;


assign w_apb0_rstn = w_clk100m_rst_n;
assign w_apb1_rstn = w_clk100m_rst_n;



apb2local u_apb2local
(

	.cfg_clk_i  (w_apb0_clk     ),
	.cfg_rstn_i (w_apb0_rstn    ),
	.cfg_addr_i (w_apb0_addr    ),
	.cfg_sel_i  (w_apb0_sel     ),
	.cfg_ena_i  (w_apb0_ena     ),
	.cfg_wr_i   (w_apb0_wr      ),
	.cfg_rdata_o(w_apb0_rdata   ),
	.cfg_wdata_i(w_apb0_wdata   ),
	.cfg_rdy_o  (w_apb0_rdy     ),
	.cfg_strb_i (w_apb0_strb    ),
	
	.local_wren_o(local_wren_w),
	.local_addr_o(local_addr_w),
	.local_strb_o(local_strb_w),
	.local_rden_o(local_rden_w),
	.local_wdat_o(local_wdat_w),
	.local_rdat_i(local_rdat_w),
	.local_rdat_vld_i(local_rdat_vld_w),
	.local_wdat_rdy_i(local_wdat_rdy_w)


);



local2reg u_local2reg
(

	.cfg_clk_i(w_apb0_clk),
	.cfg_rstn_i(w_apb0_rstn),
	.local_wren_i(local_wren_w),
	.local_addr_i(local_addr_w),
	.local_strb_i(4'hf),	
	.local_rden_i(local_rden_w),
	.local_wdat_i(local_wdat_w),
	.local_rdat_o(local_rdat_w),
	.local_rdat_vld_o(local_rdat_vld_w),
	.local_wdat_rdy_o(local_wdat_rdy_w),	
	
	
	.reg0x0000(reg0x0000),.reg0x0010(reg0x0010),.mon0x0080(mon0x0080),.mon0x0090(mon0x0090),
	.reg0x0001(reg0x0001),.reg0x0011(reg0x0011),.mon0x0081(mon0x0081),.mon0x0091(mon0x0091),
	.reg0x0002(reg0x0002),.reg0x0012(reg0x0012),.mon0x0082(mon0x0082),.mon0x0092(mon0x0092),
    .reg0x0003(reg0x0003),.reg0x0013(reg0x0013),.mon0x0083(mon0x0083),.mon0x0093(mon0x0093),
    .reg0x0004(reg0x0004),.reg0x0014(reg0x0014),.mon0x0084(mon0x0084),.mon0x0094(mon0x0094),
    .reg0x0005(reg0x0005),.reg0x0015(reg0x0015),.mon0x0085(mon0x0085),.mon0x0095(mon0x0095),
    .reg0x0006(reg0x0006),.reg0x0016(reg0x0016),.mon0x0086(mon0x0086),.mon0x0096(mon0x0096),
    .reg0x0007(reg0x0007),.reg0x0017(reg0x0017),.mon0x0087(mon0x0087),.mon0x0097(mon0x0097),
    .reg0x0008(reg0x0008),.reg0x0018(reg0x0018),.mon0x0088(mon0x0088),.mon0x0098(mon0x0098),
    .reg0x0009(reg0x0009),.reg0x0019(reg0x0019),.mon0x0089(mon0x0089),.mon0x0099(mon0x0099),
    .reg0x000A(reg0x000A),.reg0x001A(reg0x001A),.mon0x008A(mon0x008A),.mon0x009A(mon0x009A),
    .reg0x000B(reg0x000B),.reg0x001B(reg0x001B),.mon0x008B(mon0x008B),.mon0x009B(mon0x009B),
    .reg0x000C(reg0x000C),.reg0x001C(reg0x001C),.mon0x008C(mon0x008C),.mon0x009C(mon0x009C),
    .reg0x000D(reg0x000D),.reg0x001D(reg0x001D),.mon0x008D(mon0x008D),.mon0x009D(mon0x009D),
    .reg0x000E(reg0x000E),.reg0x001E(reg0x001E),.mon0x008E(mon0x008E),.mon0x009E(mon0x009E),
    .reg0x000F(reg0x000F),.reg0x001F(reg0x001F),.mon0x008F(mon0x008F),.mon0x009F(mon0x009F)   
	
	
	
);
////////////////////////////////////////////////////////////



wire           local1_wren_w/* synthesis syn_preserve = 1 */;
wire [29:0]    local1_addr_w/* synthesis syn_preserve = 1 */;
wire           local1_rden_w/* synthesis syn_preserve = 1 */;
wire [31:0]    local1_wdat_w/* synthesis syn_preserve = 1 */;
wire [31:0]    local1_rdat_w/* synthesis syn_preserve = 1 */;
wire [3 :0]    local1_strb_w/* synthesis syn_preserve = 1 */;
wire           local1_rdat_vld_w /* synthesis syn_preserve = 1 */;
wire           local1_wdat_rdy_w /* synthesis syn_preserve = 1 */;


apb2local u1_apb2local
(

	.cfg_clk_i  (w_apb1_clk     ),
	.cfg_rstn_i (w_apb1_rstn    ),
	.cfg_addr_i (w_apb1_addr    ),
	.cfg_sel_i  (w_apb1_sel     ),
	.cfg_ena_i  (w_apb1_ena     ),
	.cfg_wr_i   (w_apb1_wr      ),
	.cfg_rdata_o(w_apb1_rdata   ),
	.cfg_wdata_i(w_apb1_wdata   ),
	.cfg_rdy_o  (w_apb1_rdy     ),
	.cfg_strb_i (w_apb1_strb    ),
	
	.local_wren_o(local1_wren_w),
	.local_addr_o(local1_addr_w),
	.local_strb_o(local1_strb_w),
	.local_rden_o(local1_rden_w),
	.local_wdat_o(local1_wdat_w),
	.local_rdat_i(local1_rdat_w),
	.local_rdat_vld_i(local1_rdat_vld_w),
	.local_wdat_rdy_i(local1_wdat_rdy_w)
);


reg r1_local1_wren = 0;
reg r2_local1_wren = 0;
reg r1_local1_rden = 0;
reg r2_local1_rden = 0;



i2c_master_cfgport u_i2c_master_cfgport(
	.cfg_clk_i      (w_apb1_clk               ), 
	.cfg_rstn_i     (w_apb1_rstn              ), 
	.cfg_wren_i     (local1_wren_w            ), 
	.cfg_addr_i     (local1_addr_w            ), 
	.cfg_rden_i     (local1_rden_w            ),
	.cfg_wdat_i     (local1_wdat_w            ), 
	.cfg_rdat_o     (local1_rdat_w            ), 
	.cfg_rdat_vld_o (local1_rdat_vld_w        ), 
	.cfg_wdat_rdy_o (local1_wdat_rdy_w        ), 
	.cfg_inta_o     (                         ),
	.scl_io         (io_eeprom_scl            ), 
	.sda_io         (io_eeprom_sda             ) 
);






assign mon0x008A = 32'h20231127;
assign mon0x008B = 32'h00000001;




endmodule






